'==============================================================================
'
'   PBNOTE.BAS example for PowerBASIC For Windows
'   Copyright (c) 1997-2008 PowerBASIC, Inc.
'   All Rights Reserved.
'
'   A simple text editor using MDI windows.
'
'   Note:  Windows 95 "thunks down" to the 16-bit GDI for edit boxes, so
'          edit boxes are limited to 64k in Windows 95.  Edit controls in
'          Windows NT have a higher limit, here we set 1,048,576 bytes.
'
'==============================================================================

'------------------------------------------------------------------------------
' Initial Declares - first eliminate unnecessary functions in COMMCTRL.INC
'------------------------------------------------------------------------------
%NOANIMATE         = 1  ' Animate control
%NOBUTTON          = 1  ' Button
%NOCOMBO           = 1  ' Combo box
%NOCOMBOEX         = 1  ' ComboBoxEx
%NODATETIMEPICK    = 1  ' Date/time picker
%NODRAGLIST        = 1  ' Drag list control
%NOEDIT            = 1  ' Edit control
%NOFLATSBAPIS      = 1  ' Flat scroll bar
%NOHEADER          = 1  ' Header control
%NOHOTKEY          = 1  ' HotKey control
%NOIMAGELIST       = 1  ' Image APIs
%NOIPADDRESS       = 1  ' IP Address edit control
%NOLIST            = 1  ' List box control
%NOLISTVIEW        = 1  ' ListView control
%NOMENUHELP        = 1  ' Menu help
%NOMONTHCAL        = 1  ' MonthCal
%NOMUI             = 1  ' MUI
%NONATIVEFONTCTL   = 1  ' Native Font control
%NOPAGESCROLLER    = 1  ' Pager
%NOPROGRESS        = 1  ' Progress control
%NOREBAR           = 1  ' Rebar control
' %NOSTATUSBAR     = 1  ' Status bar
%NOTABCONTROL      = 1  ' Tab control
' %NOTOOLBAR       = 1  ' Tool bar
' %NOTOOLTIPS      = 1  ' Tool tips
%NOTRACKBAR        = 1  ' Track bar
%NOTRACKMOUSEEVENT = 1  ' Track Mouse Event
%NOTREEVIEW        = 1  ' TreeView
%NOUPDOWN          = 1  ' Up Down arrow control
'--------------------------------------------------------------------
%USEMACROS         = 1  ' Use Macros in include files, where possible

'--------------------------------------------------------------------
#COMPILER PBWIN 9
#COMPILE EXE
#DIM ALL
'--------------------------------------------------------------------
#RESOURCE "PBNote.pbr"
'--------------------------------------------------------------------
#INCLUDE "Win32API.inc"  ' contains Win32 API declares and equates, etc.
#INCLUDE "CommCtrl.inc"  ' contains Common control declares and equates, etc.
#INCLUDE "InitCtrl.inc"  ' contains improved initiation for Common controls
#INCLUDE "ComDlg32.inc"  ' contains Common dialog declares and equates, etc.
#INCLUDE "MDI32.inc"     ' contains wrappers for some MDI-related calls

'--------------------------------------------------------------------
%ID_TOOLBAR           = %WM_USER      + 1024   ' Toolbar id
%IDB_BUTTONS          = %ID_TOOLBAR   + 1      ' Button id's start here
%IDC_EDIT             = %IDB_BUTTONS  + 1      ' Edit control id

' FILE
%IDM_NEW              = %WM_USER      + 2048   ' New File
%IDM_OPEN             = %IDM_NEW      + 1      ' Open File
%IDM_SAVE             = %IDM_OPEN     + 1      ' Save
%IDM_SAVEAS           = %IDM_SAVE     + 1      ' Save As
%IDM_EXIT             = %IDM_SAVEAS   + 1      ' Exit

' EDIT
%IDM_UNDO             = %IDM_EXIT     + 1      ' Undo
%IDM_CLEAR            = %IDM_UNDO     + 1      ' Clear
%IDM_CUT              = %IDM_CLEAR    + 1      ' Cut
%IDM_COPY             = %IDM_CUT      + 1      ' Copy
%IDM_PASTE            = %IDM_COPY     + 1      ' Paste

' WINDOW
%IDM_TILE             = %IDM_PASTE    + 1      ' Tile windows
%IDM_CASCADE          = %IDM_TILE     + 1      ' Cascade windows
%IDM_ARRANGE          = %IDM_CASCADE  + 1      ' Arrange icons
%IDM_CLOSE            = %IDM_ARRANGE  + 1      ' Close all

' HELP
%IDM_ABOUT            = %IDM_CLOSE    + 1      ' About box

'------------------------------------------------------------------------------
GLOBAL hInst      AS DWORD
GLOBAL hStatus    AS DWORD
GLOBAL hToolbar   AS DWORD
GLOBAL hWndMain   AS DWORD
GLOBAL hWndClient AS DWORD
GLOBAL hFont      AS DWORD
GLOBAL fClosed    AS LONG
GLOBAL NewComCtl  AS CURRENCYX

'------------------------------------------------------------------------------
DECLARE FUNCTION AboutProc (BYVAL hDlg AS DWORD, BYVAL wMsg AS DWORD, _
                    BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION FileNam  (BYVAL Src AS STRING) AS STRING
DECLARE FUNCTION FilePath (BYVAL Src AS STRING) AS STRING
DECLARE FUNCTION GetEdit() AS LONG

'------------------------------------------------------------------------------
DECLARE SUB CenterWindow (BYVAL hWnd AS DWORD)
DECLARE SUB SAVEFILE     (BYVAL Ask AS LONG)


'==============================================================================
FUNCTION WINMAIN (BYVAL hInstance     AS DWORD, _
                  BYVAL hPrevInstance AS DWORD, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG
'------------------------------------------------------------------------------
  ' Program entrance
  '----------------------------------------------------------------------------

    LOCAL Msg         AS tagMsg
    LOCAL wce         AS WndClassEx
    LOCAL szClassName AS ASCIIZ * 80
    LOCAL hMenu       AS DWORD
    LOCAL hAccel      AS DWORD
    LOCAL vi          AS OSVERSIONINFO

    hInst = hInstance

    ' Detect version of Windows
    vi.dwOsVersionInfoSize = SIZEOF(vi)
    GetVersionEx vi

    ' Register Main Window Class
    szClassName       = "PBNOTE"
    wce.cbSize        = SIZEOF(wce)
    wce.STYLE         = %CS_HREDRAW OR %CS_VREDRAW
    wce.lpfnWndProc   = CODEPTR(WndProc)
    wce.cbClsExtra    = 0
    wce.cbWndExtra    = 0
    wce.hInstance     = hInstance
    wce.hIcon         = LoadIcon(hInstance, "PROGRAM")
    wce.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
    wce.hbrBackground = %COLOR_APPWORKSPACE + 1
    wce.lpszMenuName  = %NULL
    wce.lpszClassName = VARPTR(szClassName)
    wce.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
    IF ISFALSE(RegisterClassEx(wce)) THEN
        RegisterClass BYVAL (VARPTR(wce) + 4)
    END IF

    ' Register Code Window Class
    szClassName       = "PBNOTE32"
    wce.cbSize        = SIZEOF(wce)
    wce.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS
    wce.lpfnWndProc   = CODEPTR(CodeProc)
    wce.cbClsExtra    = 0
    wce.cbWndExtra    = 4
    wce.hInstance     = hInst
    wce.hIcon         = LoadIcon(hInstance, "NOTE")
    wce.hCursor       = LoadCursor(%NULL, BYVAL %IDC_IBEAM)
    wce.hbrBackground = %COLOR_WINDOW + 1
    wce.lpszMenuName  = %NULL
    wce.lpszClassName = VARPTR(szClassName)
    wce.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
    IF ISFALSE(RegisterClassEx(wce)) THEN
        RegisterClass BYVAL (VARPTR(wce) + 4)
    END IF

    hMenu = LoadMenu(hInstance, "MAINMENU")

    ' Create a window using the registered class
    hWndMain = CreateWindow("PBNOTE", _               ' window class name
                            "PBNOTE", _               ' window caption
                            %WS_OVERLAPPEDWINDOW, _   ' window style
                            %CW_USEDEFAULT, _         ' initial x position
                            %CW_USEDEFAULT, _         ' initial y position
                            %CW_USEDEFAULT, _         ' initial x size
                            %CW_USEDEFAULT, _         ' initial y size
                            %NULL, _                  ' parent window handle
                            hMenu, _                  ' window menu handle
                            hInstance, _              ' program instance handle
                            BYVAL %NULL)              ' creation parameters

    hFont  = GetStockObject(%ANSI_FIXED_FONT)
    hAccel = LoadAccelerators(hInstance, "PBNOTE")

    ShowWindow hWndMain, iCmdShow
    UpdateWindow hWndMain

    ' Message handler loop
    WHILE GetMessage(Msg, BYVAL %NULL, 0, 0)
        IF ISFALSE TranslateMDISysAccel(hWndClient, Msg) THEN
            IF ISFALSE TranslateAccelerator(hWndMain, hAccel, Msg) THEN
                TranslateMessage Msg
                DispatchMessage Msg
            END IF
        END IF
    WEND

    FUNCTION = msg.wParam

END FUNCTION  ' WinMain


'==============================================================================
FUNCTION WndProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                  BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
'------------------------------------------------------------------------------
  ' Main window procedure
  '----------------------------------------------------------------------------

    LOCAL dwProc      AS DWORD
    LOCAL lpToolTip   AS TOOLTIPTEXT PTR
    LOCAL cc          AS CLIENTCREATESTRUCT
    LOCAL hMdi        AS DWORD
    LOCAL hEdit       AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL f           AS STRING
    LOCAL PATH        AS STRING
    LOCAL hWndFirst   AS DWORD
    LOCAL hWndActive  AS DWORD
    LOCAL hWndPrev    AS DWORD

    STATIC tRect      AS RECT
    STATIC zText      AS ASCIIZ * 255
    STATIC ToolHeight AS LONG
    STATIC StatHeight AS LONG

    SELECT CASE wMsg

    CASE %WM_CREATE

        DIM tbb(0 TO 6) AS STATIC TBBUTTON

        '------------------------------------------------------------------------
        ' some of CommCtrl.dll's controls, messages and styles were not included
        ' in standard Win95A release, so we need to see how to initiate the dll.
        '------------------------------------------------------------------------
        NewComCtl = InitComctl32 (%ICC_BAR_CLASSES)
        '------------------------------------------------------------------------

        ' Fill the TBBUTTON array with button information
        tbb(0).iBitmap   = %STD_FILENEW
        tbb(0).idCommand = %IDM_NEW
        tbb(0).fsState   = %TBSTATE_ENABLED
        tbb(0).fsStyle   = %TBSTYLE_BUTTON
        tbb(0).dwData    = 0
        tbb(0).iString   = 0

        tbb(1).iBitmap   = %STD_FILEOPEN
        tbb(1).idCommand = %IDM_OPEN
        tbb(1).fsState   = %TBSTATE_ENABLED
        tbb(1).fsStyle   = %TBSTYLE_BUTTON
        tbb(1).dwData    = 0
        tbb(1).iString   = 0

        tbb(2).iBitmap   = %STD_FILESAVE
        tbb(2).idCommand = %IDM_SAVE
        tbb(2).fsState   = %TBSTATE_ENABLED
        tbb(2).fsStyle   = %TBSTYLE_BUTTON
        tbb(2).dwData    = 0
        tbb(2).iString   = 0

        tbb(3).iBitmap   = 0
        tbb(3).idCommand = 0
        tbb(3).fsState   = %TBSTATE_ENABLED
        tbb(3).fsStyle   = %TBSTYLE_SEP
        tbb(3).dwData    = 0
        tbb(3).iString   = 0

        tbb(4).iBitmap   = %STD_CUT
        tbb(4).idCommand = %IDM_CUT
        tbb(4).fsState   = %TBSTATE_ENABLED
        tbb(4).fsStyle   = %TBSTYLE_BUTTON
        tbb(4).dwData    = 0
        tbb(4).iString   = 0

        tbb(5).iBitmap   = %STD_COPY
        tbb(5).idCommand = %IDM_COPY
        tbb(5).fsState   = %TBSTATE_ENABLED
        tbb(5).fsStyle   = %TBSTYLE_BUTTON
        tbb(5).dwData    = 0
        tbb(5).iString   = 0

        tbb(6).iBitmap   = %STD_PASTE
        tbb(6).idCommand = %IDM_PASTE
        tbb(6).fsState   = %TBSTATE_ENABLED
        tbb(6).fsStyle   = %TBSTYLE_BUTTON
        tbb(6).dwData    = 0
        tbb(6).iString   = 0

        ' Create the status bar window
        hStatus = CreateStatusWindow(%WS_CHILD OR %WS_BORDER OR %WS_VISIBLE OR %SBS_SIZEGRIP, _
                                     "", hWnd, 200)

        ' Create the toolbar window
        hToolbar = CreateToolbarEx(hWnd, %WS_CHILD OR %TBSTYLE_TOOLTIPS, _
                                   %ID_TOOLBAR, 12, %HINST_COMMCTRL, %IDB_STD_SMALL_COLOR, _
                                   tbb(0), 7, 0, 0, 100, 30, LEN(TBBUTTON))

        ' Create MDI Client window
        cc.idFirstChild = 0
        hWndClient = CreateWindowEx(%WS_EX_CLIENTEDGE, "MDICLIENT", BYVAL %NULL, _
                                    %WS_CHILD OR %WS_CLIPCHILDREN OR %WS_VISIBLE OR %WS_VSCROLL OR %WS_HSCROLL, _
                                    0, 0, 0, 0, hWnd, &H0CAC, hInst, cc)

        ' auto-size the toolbar
        SendMessage hToolbar, %TB_AUTOSIZE, 0, 0

        ' see if we can use modern features like flat style, etc,
        '  which came in Win98/CommCtrl.dll v4.70 (MSIE 4.00)
        IF NewComCtl >= 4.7 THEN
           SetWindowLong hToolbar, %GWL_STYLE, _
              GetWindowLong(hToolbar, %GWL_STYLE) OR %TBSTYLE_FLAT
        END IF

        ' Display the toolbar
        ShowWindow hToolbar, %SW_SHOW

        'Get the size of the toolbar and status bar
        GetWindowRect hToolbar, tRect
        ToolHeight = tRect.nBottom - tRect.nTop
        GetWindowRect hStatus, tRect
        StatHeight = tRect.nBottom - tRect.nTop
        EXIT FUNCTION

    CASE %WM_SIZE
        IF wParam <> %SIZE_MINIMIZED THEN
          SendMessage hStatus, wMsg, wParam, lParam
          SendMessage hToolbar, wMsg, wParam, lParam
          GetClientRect hWnd, tRect
          MoveWindow hWndClient, _
                     tRect.nLeft, _
                     ToolHeight, _
                     tRect.nRight, _
                     tRect.nBottom - (ToolHeight + StatHeight), _
                     %TRUE
        END IF
        EXIT FUNCTION

    CASE %WM_NOTIFY
        lpToolTip = lParam
        IF @lpToolTip.hdr.code = %TTN_NEEDTEXT THEN
            LoadString hInst, @lpToolTip.hdr.idFrom, zText, SIZEOF(zText)
            @lpToolTip.lpszText = VARPTR(zText)
        END IF
        EXIT FUNCTION

    CASE %WM_MENUSELECT
        LoadString hInst, LOWRD(wParam), zText, SIZEOF(zText)
        SendMessage hStatus, %WM_SETTEXT, 0, VARPTR(zText)
        EXIT FUNCTION

    CASE %WM_COMMAND

        hEdit = GetEdit

        SELECT CASE LOWRD(wParam)

        CASE %IDM_NEW
            hMdi = CreateMdiChild("PBNOTE32", hWndClient, "", 0)
            ShowWindow hMdi, %SW_SHOW
            EXIT FUNCTION

        CASE %IDM_OPEN
            PATH  = CURDIR$
            f     = "*.txt"
              dwStyle = %OFN_EXPLORER OR %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY
            IF OpenFileDialog(hWndMain, "", f, PATH, _
                              "Text Files|*.txt|All Files|*.*", "txt", dwStyle) THEN
                hMdi = CreateMdiChild("PBNOTE32", hWndClient, f, 0)
                ShowWindow hMdi, %SW_SHOW
            END IF

        CASE %IDM_SAVE
            IF hEdit THEN SAVEFILE %FALSE

        CASE %IDM_SAVEAS
            IF hEdit THEN SAVEFILE %TRUE

        CASE %IDM_EXIT
            SendMessage hWnd, %WM_CLOSE, wParam, lParam

        CASE %IDM_ABOUT
            dwProc = CODEPTR(AboutProc)
            DialogBox hInst, "ABOUT", hWnd, dwProc

        CASE %IDM_CLOSE
            hWndFirst = MdiGetActive(hWndClient)
            hWndActive = hWndFirst
            hWndPrev = 0
            DO WHILE hWndActive
                IF SendMessage(MdiGetActive(hWndClient), %WM_CLOSE, 0, 0) THEN
                    EXIT DO
                END IF
                IF fClosed THEN
                    IF hWndFirst = hWndActive THEN
                        IF hWndFirst = hWndPrev THEN
                            hWndFirst = 0
                            hWndPrev = 0
                        ELSE
                            hWndFirst = hWndPrev
                      END IF
                    END IF
                ELSE
                    IF hWndPrev = 0 THEN
                        hWndPrev = hWndActive
                    END IF
                    IF hWndFirst = 0 THEN
                        hWndFirst = hWndActive
                    END IF
                END IF
                MdiNext(hWndClient, hWndActive, 0&)
                hWndActive = MdiGetActive(hWndClient)
            LOOP UNTIL hWndActive = hWndFirst

        CASE %IDM_CUT
            IF hEdit THEN SendMessage hEdit, %WM_CUT, 0, 0

        CASE %IDM_COPY
            IF hEdit THEN SendMessage hEdit, %WM_COPY, 0, 0

        CASE %IDM_PASTE
            IF hEdit THEN SendMessage hEdit, %WM_PASTE, 0, 0

        CASE %IDM_UNDO
            IF hEdit THEN SendMessage hEdit, %EM_UNDO, 0, 0

        CASE %IDM_CLEAR
            IF hEdit THEN SendMessage hEdit, %WM_CLEAR, 0, 0

        CASE %IDM_TILE
            IF hEdit THEN MdiTile(hWndClient, %WM_MDITILE)

        CASE %IDM_CASCADE
            IF hEdit THEN MdiCascade(hWndClient)

        CASE %IDM_ARRANGE
            IF hEdit THEN MdiIconArrange(hWndClient)

      END SELECT

    CASE %WM_CLOSE
        hWndFirst = MdiGetActive(hWndClient)
        hWndActive = hWndFirst
        hWndPrev = 0
        DO WHILE hWndActive
            IF SendMessage(MdiGetActive(hWndClient), %WM_CLOSE, 0, 0) THEN
                EXIT DO
            END IF
            IF fClosed THEN
                IF hWndFirst = hWndActive THEN
                  IF hWndFirst = hWndPrev THEN
                      hWndFirst = 0
                      hWndPrev = 0
                  ELSE
                      hWndFirst = hWndPrev
                  END IF
                END IF
            ELSE
                IF hWndPrev = 0 THEN
                    hWndPrev = hWndActive
                END IF
                IF hWndFirst = 0 THEN
                    hWndFirst = hWndActive
                END IF
            END IF
            MdiNext(hWndClient, hWndActive, 0&)
            hWndActive = MdiGetActive(hWndClient)
        LOOP UNTIL hWndActive = hWndFirst
        IF hWndActive THEN
            EXIT FUNCTION
        END IF

    CASE %WM_DESTROY
        PostQuitMessage 0
        EXIT FUNCTION

    END SELECT

    FUNCTION = DefFrameProc(hWnd, hWndClient, wMsg, wParam, lParam)

END FUNCTION


'==============================================================================
FUNCTION CodeProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS LONG, _
                   BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
'------------------------------------------------------------------------------
  ' NotePad procedure - handle messages from the MDI child windows.
  '----------------------------------------------------------------------------
    LOCAL hEdit  AS LONG
    LOCAL nFile  AS LONG
    LOCAL Buffer AS STRING
    LOCAL RetVal AS LONG

    STATIC rc    AS RECT
    STATIC zText AS ASCIIZ * %MAX_PATH

    SELECT CASE wMsg

    CASE %WM_CREATE
        GetClientRect hWnd, rc
        hEdit = CreateWindowEx(%WS_EX_CLIENTEDGE, "Edit", BYVAL %NULL, %WS_CHILD OR %WS_VISIBLE OR _
                               %ES_MULTILINE OR %WS_VSCROLL OR %WS_HSCROLL OR _
                               %ES_AUTOHSCROLL OR %ES_AUTOVSCROLL OR %ES_NOHIDESEL, _
                               0, 0, 0, 0, hWnd, %IDC_EDIT, hInst, BYVAL %NULL)

        SendMessage hEdit, %WM_SETFONT, hFont, 0
        SendMessage hEdit, %EM_SETLIMITTEXT, &H100000&, 0

        GetWindowText hWnd, zText, SIZEOF(zText)
        IF LEN(zText) THEN
            nFile = FREEFILE
            OPEN zText FOR BINARY AS nFile
            GET$ nFile, LOF(nFile), Buffer
            CLOSE nFile
            SetWindowText hEdit, BYVAL STRPTR(Buffer)
        ELSE
            SetWindowText hWnd, "Untitled"
        END IF

    CASE %WM_SIZE
        MoveWindow GetDlgItem(hWnd, %IDC_EDIT), 0, 0, LOWRD(lParam), HIWRD(lParam), %TRUE

    CASE %WM_SETFOCUS
        SetFocus GetEdit

    CASE %WM_CLOSE
        IF SendMessage(GetEdit, %EM_GETMODIFY, 0, 0) THEN
            GetWindowText hWnd, zText, SIZEOF(zText)
            RetVal = MSGBOX("Save current changes? " & FileNam(zText), _
                            %MB_YESNOCANCEL OR %MB_ICONEXCLAMATION, _
                            "PBNOTE")
            IF RetVal = %IDCANCEL THEN
                fClosed = %FALSE
                EXIT FUNCTION
            ELSE
                fClosed = %TRUE
                IF RetVal = %IDYES THEN
                    SAVEFILE %FALSE
                END IF
            END IF
        ELSE
            fClosed = %TRUE
        END IF

    END SELECT

    FUNCTION = DefMDIChildProc(hWnd, wMsg, wParam, lParam)

END FUNCTION


'==============================================================================
FUNCTION AboutProc (BYVAL hDlg AS DWORD, BYVAL wMsg AS DWORD, _
                    BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
'------------------------------------------------------------------------------
  ' About box dialog procedure
  '----------------------------------------------------------------------------

    SELECT CASE wMsg
    CASE %WM_INITDIALOG
        CenterWindow hDlg
        EnableWindow hWndMain, %FALSE
        FUNCTION = 1

    CASE %WM_COMMAND
        SELECT CASE LOWRD(wParam)

        CASE %IDCANCEL
            EndDialog hDlg, 0
            EnableWindow hWndMain, %TRUE
            FUNCTION = 1

        CASE %IDOK, 103
            EndDialog hDlg, 1
            EnableWindow hWndMain, %TRUE
            FUNCTION = 1
        END SELECT

    END SELECT

END FUNCTION


'==============================================================================
SUB CenterWindow (BYVAL hWnd AS DWORD)
'------------------------------------------------------------------------------
  ' Center a window on screen
  '----------------------------------------------------------------------------

    LOCAL WndRect AS RECT
    LOCAL x       AS LONG
    LOCAL y       AS LONG

    GetWindowRect hWnd, WndRect

    x = (GetSystemMetrics(%SM_CXSCREEN) - (WndRect.nRight-WndRect.nLeft)) \ 2
    y = (GetSystemMetrics(%SM_CYSCREEN) - (WndRect.nBottom - WndRect.nTop + GetSystemMetrics(%SM_CYCAPTION))) \ 2

    SetWindowPos hWnd, %NULL, x, y, 0, 0, %SWP_NOSIZE OR %SWP_NOZORDER

END SUB


'==============================================================================
FUNCTION FileNam (BYVAL Src AS STRING) AS STRING
'------------------------------------------------------------------------------
  ' Get file name part of given path + name
  '----------------------------------------------------------------------------

    FUNCTION = MID$(Src, INSTR(-1, Src, ANY ":/\") + 1)

END FUNCTION


'==============================================================================
FUNCTION FilePath (BYVAL Src AS STRING) AS STRING
'------------------------------------------------------------------------------
  ' Get file path part of given path + name
  '----------------------------------------------------------------------------

    FUNCTION = LEFT$(Src, INSTR(-1, Src, ANY ":\/"))

END FUNCTION


'==============================================================================
FUNCTION GetEdit() AS LONG
'------------------------------------------------------------------------------
  ' Get active MDI child's edit control, if any
  '----------------------------------------------------------------------------

    FUNCTION = GetDlgItem(MdiGetActive(hWndClient), %IDC_EDIT)

END FUNCTION


'==============================================================================
SUB SAVEFILE (BYVAL Ask AS LONG)
'------------------------------------------------------------------------------
  ' Save as -procedure
  '----------------------------------------------------------------------------

    LOCAL PATH    AS STRING
    LOCAL f       AS STRING
    LOCAL dwStyle AS DWORD
    LOCAL nFile   AS DWORD
    LOCAL Buffer  AS STRING
    LOCAL zText   AS ASCIIZ * %MAX_PATH

    GetWindowText MdiGetActive(hWndClient), zText, SIZEOF(zText)
    IF zText = "Untitled" THEN
        PATH = CURDIR$
        Ask  = %TRUE
    ELSE
        PATH = FilePath(zText)
        f    = FileNam(zText)
    END IF
    dwStyle = %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY OR _
              %OFN_EXPLORER OR %OFN_OVERWRITEPROMPT

    IF Ask THEN
        IF ISFALSE SaveFileDialog(hWndMain, "", f, PATH, _
                   "Text Files|*.txt|All Files|*.*", "txt", dwStyle) THEN
            EXIT SUB
        END IF
    END IF

    nFile = FREEFILE
    OPEN f FOR BINARY AS nFile
      IF ERR THEN   ' if something went wrong
          MSGBOX "Following error occured while trying to save the file:" + $CRLF + _
                 "Error:" + STR$(ERR) + ", " + ERROR$(ERR)+ $CRLF + $CRLF + _
                 "The file could not be saved.", _
                 %MB_ICONWARNING OR %MB_OK OR %MB_TASKMODAL, _
                 "Save file error!"
          EXIT SUB
      END IF

      Buffer = SPACE$(GetWindowTextLength(GetEdit) + 1)
      GetWindowText GetEdit, BYVAL STRPTR(Buffer), LEN(Buffer)
      PUT$ nFile, LEFT$(Buffer, LEN(Buffer) - 1)
      SETEOF nFile
    CLOSE nFile

    SetWindowText MdiGetActive(hWndClient), BYVAL STRPTR(f)
    SendMessage GetEdit, %EM_SETMODIFY, 0, 0

END SUB
